<?php
// vim:filetype=php expandtab tabstop=2 softtabstop=2 shiftwidth=2 autoindent smartindent
// $Id: url.inc,v 1.3 2008/08/30 22:51:38 seeschloss Exp $

function tribune_url_info() {
  $info = array(
    'description' => t("Turns 'http://...' into clickable links."),
    'weight'      => 0,
  );

  return $info;
}

function tribune_url_filter_after(&$post, &$help) {
  $post['parsed'] = preg_replace_callback('#((https?|ftp|gopher|file|mms|rtsp|rtmp)://.*?)((,|\.|\)|\])?(<| | |"|$))#', 'tribune_url_replace', $post['parsed']);
}

function tribune_url_replace($matches) {
  $url = $matches[1];
  $text = 'url';

  foreach (explode("\n", variable_get('tribune_url_replacement', "")) as $line) {
    preg_match(':^/(.*[^\\\\])/(.*)$:U', trim($line), $result);

    if (count($result) == 3) {
      if (@preg_match('/'. $result[1] .'/', $url)) {
        $text = trim($result[2]);
      }
    }
  }

  return '<a href="'. $url .'">['. $text .']</a>'. $matches[3];
}

function tribune_url_settings() {
  $form = array();

  $form['tribune_url_replacement'] = array(
    '#type'           => "textarea",
    '#title'          => t("URL replacement expressions"),
    '#default_value'  => variable_get('tribune_url_replacement', ""),
    '#description'    => t("Use this format: <code>/regexp/ replacement string</code><br />You can escape /'s in the regexp with a \.<br />If any url matches an expression (according to <code>!preg_match_url</code>), it will be replaced with <em>[replacement string]</em> instead of the default <em>[url]</em>.", array('!preg_match_url' => l('preg_match', 'http://php.net/preg_match'))),
  );

  return system_settings_form($form);
}
