<?php
// vim:filetype=php expandtab tabstop=2 softtabstop=2 shiftwidth=2 autoindent smartindent
// $Id: tribune.backend.inc,v 1.4 2008/08/30 22:51:38 seeschloss Exp $


/**
  * Print the XML backend
  */
function tribune_xml() {
  header("Content-Type: text/xml");
  print print_posts_xml(variable_get('tribune_xml_size', 100));
  exit();
}

/**
  * Returns the $nb last posts, in XML format
  * @param nb Number of posts to return (tribune_history_size by default)
  * @return String containing the posts in an HTML unordered list
  */
function print_posts_xml($nb = -1) {
  if ($nb < 0) {
    $nb = variable_get("tribune_xml_size", 100);
  }

  $contents  = "<?xml version=\"1.0\" encoding=\"UTF-8\""."?".">\n"; // defeat vim's buggy highlighting
  $contents .= "<!DOCTYPE board PUBLIC \"C01N C01N !\" \"http://phplop.org/dtd/tribune-1.0.dtd\">\n";
  $posts = get_last_posts($nb);

  $site_root = url(NULL, array('absolute' => TRUE)) . (variable_get('clean_url', 0) ? '' : '?q=');
  $timezone = variable_get('date_default_timezone', 0);
  $tz = "UTC". ($timezone < 0 ? "-" : "+") . round($timezone/3600);
  $contents .= "<board site=\"". $site_root ."tribune\" timezone=\"". $tz ."\">\n";

  $posts = array_reverse($posts);

  foreach ($posts as $id => $post) {
    if ($post['moderated'] == 0) {
      $contents .= print_post_xml($post);
    }
  }

  $contents .= "</board>\n";

  return $contents;
}

/**
  * Returns a single post, in XML format
  * @param post Array with the following keys : id, clock, login, info, message
  */
function print_post_xml($post) {
  $contents  = "    <post time=\"". $post['clock']  ."\" id=\"". $post['id'] ."\">\n";
  $contents .= "        <info>"   . $post['info']   ."</info>\n";
  $contents .= "        <message>". tribune_xml_slip($post['message']) ."</message>\n";
  $contents .= "        <login>"  . $post['login']  ."</login>\n";
  $contents .= "    </post>\n";

  return $contents;
}
